
var _ucdbLoginFlag = true

var phoneTimer;

function isucdbSuccessedLogin()
{
	return _ucdbLoginFlag;
}

function hideucdbFolders()
{
	$('.jsServiceProvider[folder=CDR]').hide()
	$('.jsServiceProvider[folder=SMS]').hide()
	$('#newIM').hide()
}

function getMyIds()
{
	return ["sip:" + $phone.params.userId + "@" + $phone.params.domain, "tel:" + $phone.params.phoneNumber, "tel:" + $phone.humanize($phone.params.phoneNumber)]
}

function isOutbound(src)
{
	myids = getMyIds()
	src = $phone.humanize(src)

	for(var i=0; i<myids.length; ++i) 
	{
		if( myids[i].indexOf(src)>=0 ) 
			return true;
	}
	return false;

}

function isMe(src)
{
	return isOutbound(src)
}

function getUserId()
{
	return $phone.params.userId
}

function getPerson(src)
{
	src = $phone.humanize(src)
	if(isMe(src)) src = getUserId()
	return src
}

function countdownStart()
{
	var seconds = 0;
	var minutes = 0;
	var hours = 0;
	var total = "";
    $('.phoneTimer', '#secondary').show().html("00");
	phoneTimer = setInterval(function (){
		seconds++;
		if (seconds > 59) {
			seconds = 0;
			minutes++
		}
		if (minutes > 59) {
			minutes = 0;
			hours++;
		}
		if (hours < 1 && minutes < 1) {
			total = ((seconds < 10) ? "0"+seconds : seconds);
		}
		else if (hours < 1) {
			total = ((minutes < 10) ? "0"+minutes : minutes) + ":" + ((seconds < 10) ? "0"+seconds : seconds);
		}
        $('.phoneTimer', '#secondary').show().html(total);
	}, 1000);
}

function countdownDestroy()
{
	clearInterval(phoneTimer);
}

function updateContactFromAbook(data, caller)
{
	caller = $phone.humanize($phone.getBasicSIPURIFromRawInput(caller))
	if(!data || !data.abook_number || data.result != 'found' )
	{
		// last digit or length does match, treat as not match
		data.name = ''
		data.result = 'not found'
		data.imageUrl = data.defaultImageUrl
	}

	if( data.name == 'Unknown' )
		data.name = ''

	if( data.result == 'not found') 
	{
		$('.caller-details', '.call-connected').attr('uri', caller)
		$phone.setNewContactFlag(true)
	}

	$('.phoneRemoteImg', ".call-connected").attr('src', data.imageUrl)
	$('.phoneRemoteName', ".call-connected").html(data.name)
	$('.phoneRemoteNumber', ".call-connected").html( caller )
	$(".phoneRemoteNumber").removeClass("addContact");

	if ($('.phoneRemoteName').is(':empty'))
		$(".closeButtonUnit").removeClass("contactExists");
	else
		$(".closeButtonUnit").addClass("contactExists");

}

function isCallEnded()
{
	incall_text = $('.phoneCallStatus','.call-connected').text().toLowerCase()
	return incall_text.indexOf('ended') > 0;
}

function ping()
{

	var success=false
	var begin = new Date().getTime()

	$.ajax({
		async: false,
		type: "GET",
		url: siteBaseUrl + "images/paging.jpg",
		success: function(result) { success=true },
		error: function(result) {}
	});

	return (success)? (new Date().getTime() - begin) : 100000;

}

function networkQuality()
{

	var excellent = 50;		// if < excellent
	var good = 100;			// if > excellent < good
	var poor = 200;

	var elapsed = ping(); //also gets a small file for better scaling

	if(elapsed == 0 || elapsed < 0)
		return "no-connection";
	else if(elapsed <= excellent)
		return "excellent";
	else if(elapsed <= good)
		return "good";
	else if(elapsed >= poor)
		return "poor";

	return elapsed < excellent? "excellent" : elapsed < good? "good" : "poor";

}

$( function()
{
	
/**********************************************************************************************************
UCDB integration methods
***********************************************************************************************************/
	UCDBConnector = function(newOptions) {

		this.defaultOptions = { debug : false }
		//overite default params with specified params
		this.options = $.extend(this.defaultOptions, newOptions)

	}

	UCDBConnector.prototype.log = function( msg ) { if( this.options.debug != true ) return; if( window.console ) console.log( msg ) }
	UCDBConnector.prototype.put = function( msg ) { this.log( msg ) }
	UCDBConnector.prototype.get = function( options ) { this.log( msg ) }

	$.extend( { "UCDB" : UCDBConnector })

	ucdb = new $.UCDB({debug:false})



/**********************************************************************************************************
UI side $phone Setup and UI callback bindings/overloaded UI methods (phone events that have UI code in them should be here, No UI code should be in the jQuery Plugin)
***********************************************************************************************************/

	$phone.getPid = function(folder)
	{
		if(!folder) {
			var folder = 'SMS'
		}
		return $('.jsServiceProvider[folder=' + folder +']').attr('pid')
	}

	$phone.refreshLog = function(folder)
	{
		if( !$phone.hasSipFolder() ) return;

		if(!folder ) {
			this.log("folder must be specified to call $phone.refreshLog()");
			return;
		}

		$folder = $('.jsServiceProvider[folder=' + folder +']')

		$("DIV.current", "#Email").removeClass('current');
		$folder.parent().addClass('current');

		var dataSourceURL = $folder.attr('href')
		var pid = $folder.attr('pid')
		var myId = $folder.attr('myid')
		var myDisplayName = $folder.attr('mydisplayname')
		var folder = $folder.attr('folder') || undefined
		var serviceType = $folder.attr('servicetype') || undefined
		var serviceName = $folder.attr('servicename') || undefined
		var serviceDesription = $folder.attr('servicedesription') || undefined

		//TODO add ability to detect folder and other args our of the url (makes DOM coding simpler)
		var dataSourceParams = {
			"pid" : pid,
			"serviceType" : serviceType,
			"serviceName" : serviceName,
			"serviceDesription" : serviceDesription,
			"myId" : myId,
			"myDisplayName" : myDisplayName,
			"folder" : folder, //first folder to make sure present and return prepared with parent tree
			"limit" : "50",
			"dataSourceURL" : dataSourceURL
		}
		$.localData.checkProviderStoreReady(dataSourceParams)
		$('#Email #primary #messageList').showPanel(dataSourceURL,dataSourceParams, $.localData.dataStore["pid"+pid].folders[folder], $.templateEngine.templates.SIP[folder] )

//		$('.serviceFolderGroup [folder='+ folder + ']').click();
//		$('#Email #primary #messageList').showPanel($.localData.dataStore["pid"+pid].dataSourceURL,dataSourceParams, $.localData.dataStore["pid"+pid].folders[folder], $.templateEngine.templates.SIP[folder], false )
	}

	$phone.clearUIOfMissedCall = function()
	{
		var $unread_calls = $('.unread-CDR strong');
		$unread_calls.text('0').parent().fadeOut(600);
	}

	$phone.notifyUIOfMissedCall = function()
	{
		var $unread_calls = $('.unread-CDR strong');
		var calls = $unread_calls.text();
		++calls;
		$unread_calls.text(calls).parent().css('display', 'block')

		this.log("you missed " + calls +" call(s)!");
		$unread_calls.parent().parent().parent().parent().parent().parent().children("span.folderClosed").trigger("click")
		$("#secondary").scrollTo( $(".jsServiceProvider[folder=CDR]:last"), 1000 );//.scrollTo({top:'+=100px'})
	}

	$phone.notifyUIOfUnreadSMS = function(i)
	{
		var $unread_sms = $('.unread-SMS strong')

		if(i == 0) {
			$unread_sms.text(0)
			$unread_sms.parent().hide()
			return;
		}

		if( i != undefined )
			var smss = i
		else
		{

			var smss = $unread_sms.text()
			++smss

		}
		$unread_sms.text(smss).parent().css('display', 'block')

		//this.log("you have " + smss +" unread SMS(s)!")
		//$unread_sms.parent().parent().parent().parent().parent().parent().children("span.folderClosed").trigger("click")
		$("#secondary").scrollTo( $(".jsServiceProvider[folder=SMS]:last"), 1000 )

	}

	$phone.replaceIdInDOMWithFlashObject = function( DOMIdToReplace )
	{

		//This instantiates a flash player and connects to the RTMP server - if successful, calls the flashInstantiatedCallback
		var params = {
			menu : "true",
			swliveconnect : "true",
			allowfullscreen : "true",
			allowscriptaccess : "always",
			wmode : "transparent"
		}
		var attributes = {}
		var flashvars={}
		flashvars.config= siteBaseUrl + "js/atmail/phone/phone.xml.php";

		if( flashVersionSufficient() )
		{

			swfobject.embedSWF(siteBaseUrl + "js/atmail/phone/phone_js_api.swf", DOMIdToReplace, "100%", "100%", "11.1.102", siteBaseUrl + "js/atmail/phone/expressInstall.swf", flashvars, params, attributes, flashInstantiatedCallback);

		}
		else
		{

			//inform user that they need to upgrade their Flash player version (use same popup DIV that above triggers)

		}

	}
	//Insert flash object into the DOM
	$phone.replaceIdInDOMWithFlashObject('phone1FlashObject')

/********************************************************
UI jQuery code
*********************************************************/

	$( ".callNotifyIncoming" ).dialog(
	{
		dialogClass: 'callNotify',
		autoOpen: false,
		resizable: false,
		close : function()
		{

			//TODO: if call not answered then issue a call ignore

		}

	});

	$("#phoneGeneralPanelWrapper").dialog(
	{
		autoOpen: false,
		resizable: false,
		modal: true,
		position: 'center',
		title: 'You need Adobe Flash Player 11'
	})

	$("#phoneIMPanel").dialog(
	{
		autoOpen: false,
		resizable: false,
		position: 'center',
		title: 'Instant Message'

	})

	if( !flashVersionSufficient() )
	{

		$("#phoneGeneralPanelWrapper").dialog("open");

	}

	$("#phoneSettingsDialog").dialog(
	{
		autoOpen: false,
		resizable: false,
		title: 'Microphone Settings',
		drag : function() {
			offset = $(this).offset()
			$('#phone1').css('left', parseInt(offset.left+18) )
			$('#phone1').css('top', parseInt(offset.top+16) )
		},
		close : function() {
			$('#phone1').css('left', '' )
			$('#phone1').css('right', 200 )
			$('#phone1').css('top', 32 )
			$phone.hideFlashStageWrapper()
		}
	})

	$("#sendButton", "#phoneIMPanel").unbind().bind('click', function()
	{
		
		if($phone.params.flashConnectorHandle.sendMessage == undefined) 
		{
			alert('Lost connection to webphone server. Send message failed');
			return
		}

		var recipientsInput = $("#phoneIMTo").attr("value") //TODO: cleanup
		toSIPURIArray = $phone.getBasicSIPURIArrayFromRawInput(to)
		if( toSIPURIArray.length > 2000 )
		{

			alert("You can not send and SMS to more than 2000 recipients. Please revise your list of recipients.")
			return false

		}
		recipientsInput = toSIPURIArray.join(",")
		var message = $("#phoneIMMessage").attr("value")
		//$phone.params.flashConnectorHandle.sendMessage(to, message, "text/plain")
		//$phone.params.flashConnectorHandle.sendMessage("tel:+61400000000",null,"test 3","message/cpim")
		//$phone.params.flashConnectorHandle.sendMessage("sip:adhoc@myimsserver.com","tel:+61400000000,tel:+61400000001","test 2","multipart/mixed")
		//$phone.params.flashConnectorHandle.sendMessage("sip:adhoc@imsserver.com",to,message,"multipart/mixed")
		//$phone.params.flashConnectorHandle.sendMessage(toSIPURIbasic, null, message, "message/cpim")
		messageObject = {
			id: $phone.generateUUID(),
			to: "sip:adhoc@imsserver.com",//TODO: admin definable
			recipients: recipientsInput,
			body: message,
			contentType: "multipart/mixed"
		}
		$phone.params.flashConnectorHandle.sendMessage(messageObject)

		//TODO: multi recipient messages
		$("#phoneIMPanel").dialog("close")

	})

/********************************************************************************
$phone UI methods
for transitioning the UI through the various call flows
*********************************************************************************/


	//TODO move to final position
	$phone.uiMainModes = {
		"hidden":"hidden",
		"prepCall":"prepCall", //preparing to make an outbound call (dialier visible, and dial button visible)
		"pendingCallInbound":"pendingCallInbound", //ringing inbound call
		"pendingCallOutbound":"pendingCallOutbound", //ringing outbound call (e.g.dialed now waiting for attempt status updates e.g. RINGING, 404, busy, answered, out of credit etc.)
		"inCall":"inCall", //in a call with active timer etc (may allow additional prepCall, pendingCallx, callHeld, hungUp events on multiple calls)
		"finishedCall":"finishedCall" //failed, hungup, missed. showing date and time (last missed call - for complete missed call list, see call log ui)
	} //must handle all phone events that can happen in any of these uiMainModes

	$phone.newCall = function(callee) //prepair to place new call (open the new call dialog if was idle, else show inline dialer in inCall mode)
	{
		this.log("Trying to open new call dialog when uiMainMode is: " + this.params.uiMainMode )
		if( this.params.uiMainMode == "hidden" ||  this.params.uiMainMode == "finishedCall" ) //clear this mode and show new call ui
		{

			$phone.resetPhoneDialog()
			//done need to show a generic dial button (input already has a nice button)
			this.params.uiMainMode = "prepCall"

		}
		else if(
			   this.params.uiMainMode == "prepCall" //ignore trying to open another outboundPrep
			|| this.params.uiMainMode == "pendingCallOutbound" //don't alow trying to bring up the dialer when there is a pending outbound call
			|| this.params.uiMainMode == "pendingCallInbound" //don't alow trying to bring up the dialer when there is a pending inbound call
		)
		{



		}
		else if( this.params.uiMainMode == "inCall" ) // in a call
		{

			this.log("TODO: show neat inline input with dial button (in the inCall mode)")

		}
		else
		{

			this.log("TODO: handle this state! Trying to call newCall/prepCall while uiMainMode is " + this.params.uiMainMode)

		}

	}

	$phone.hasSipFolder = function()
	{
		return $('.serviceFolderGroup', '#nav_secondary').length > 0;
	}

/*********************************************************************************
Callbacks to the UI that the phone may make (phone makes callbacks so that the UI can be updated)
**********************************************************************************/

	//some callbacks might update or slightly change an already largly set up dialog,
	//some callbacks will totally change the dialog
	//some callbacks might update a pre-set dialog (pre-set by the initiating call that finally generated the callback) (blindly update the dialog so that UI appears to be more responsive/faster) - currently the only pre-set dialog is from newCall

	$phone.glueNotifyCallback = function ( call, pCall ) // for calls
	{
		
		if(!$phone.hasSipFolder())
			return;

		this.log('glueNotifyCallback')
		
		if( call.isMSRP )
		{
			return;
		}

		var nowTimestampUnix = parseInt(( +Date.now() || +new Date ) / 1000)		// convert to seconds

		ajaxData = false;
		var src = $phone.getBasicSIPURIFromRawInput( $phone.humanize(call.caller) )
		var dst = $phone.getBasicSIPURIFromRawInput( $phone.humanize(call.callee) )

		//workaround UCDB interpreting input as numbers (loosing leading 0s) - just allend tel: if missing (for now) - to firce string
		if( dst.indexOf("tel:") !== 0 &&  dst.indexOf("sip:") )
			dst = "tel:" + dst
			
		if( call.incoming && (call.state == "RINGING" || call.state == "RING") )															//incoming ringing
		{
			//inbound ringing
			this.log('inbound ringing');
			ajaxData = {"state" : "INITIATED", "src" : src, "dst" : dst, "callId" : call.id, "start" : nowTimestampUnix }
		}
		else if(call.state == "RINGING" || call.state == "RING")																			//outgoing ringing
		{
			//outbound dial in progress, ringing
			this.log('outbound ringing');
			ajaxData = {"state" : "INITIATED", "src" : src, "dst" : dst, "callId" : call.id, 'start' : nowTimestampUnix }
		}
		else if( call.incoming && (pCall.state == "RING" || pCall.state == "RINGING") && call.state == "TALK" )
		{
			// inbound call transition from ring to talk = answered
			this.log('inbound call transition from ring to talk = answered');
			ajaxData = {"state" : "ANSWERED", "src" : src, "dst" : dst, "callId" : call.id, 'answer' : nowTimestampUnix }
		}
		else if( !call.incoming && (pCall.state == "RING" || pCall.state == "RINGING") && call.state == "TALK" )
		{
			// outbound call transition from ring to talk = answered
			this.log('outbound call transition from ring to talk = answered');
			ajaxData = {"state" : "ANSWERED", "src" : src, "dst" : dst, "callId" : call.id, 'answer' : nowTimestampUnix }
		}
		else if( call.state == "FINISH" && call.sip_state == "404" ) //outbound dial failed callee not found
		{
			// outbound call bad number 404
			this.log('outbound call bad number 404');
			ajaxData = {"state" : "FAILED", "src" : src, "dst" : dst, "callId" : call.id }
		}
		else if( pCall.state == "HOLD" && call.state == "TALK")
		{
			// on hold
			this.log('on hold');
			if( pCall.remoteHold != undefined && pCall.remoteHold )
			{
				// remote hold transition to talk
				this.log('remote hold transition to talk');
			}
			else
			{
				// local hold transition to talk
				this.log('local hold transition to talk');
			}
		}
		else if( call.incoming && call.state == "TALK" )
		{
			// inbound call answered
			this.log('inbound call answered');
		}
		else if( !call.incoming && call.state == "TALK" ) //outbound call answered
		{
			// outbound call answered
			this.log('outbound call answered');
		}
		else if( call.incoming && (pCall.state == "RING" || pCall.state == "RINGING" ) && (call.state == "FINISH" || call.state == "STATE_IDLE") )
		{
			// missed call; inbound call now finished ringing
			ajaxData = {"state" : "MISSED", "src" : src, "dst" : dst, "callId" : call.id, 'end' : nowTimestampUnix }
			this.log('missed call');
		}
		else if( (pCall.state == "RING" || pCall.state == "RINGING" ) && (call.state == "FINISH" || call.state == "STATE_IDLE") )
		{
			// unanswered call
			this.log('unanswered call');
			ajaxData = {"state" : "NOANSWER", "src" : src, "dst" : dst, "callId" : call.id, 'end' : nowTimestampUnix }
		}
		else if( call.state == "HOLD" )
		{
			// remote party holds call
			this.log('remote party holds call');
			if( pCall.localHold != undefined && pCall.localHold )
			{
				// local hold
				this.log('local hold');
			}
			else
			{
				// remote hold
				this.log('remote hold');
			}
		}
		else if( call.state == "RING" )
		{
			// transitioning a call to ringing
			this.log('transitioning a call to ringing');
		}
		else if( pCall.state != "BUSY" && call.state == "FINISH" )
		{
			currentCall = this.getCurrentCall()
			if( call.id != currentCall.id )
			{
				
				this.log( 'webphone.phtml #539: Received a FINISH but it wasnt for the current call so ignorning (e.g. missed call handled by seperate message)' )
				return
				
			}
			// call completed
			this.log('call completed');
			ajaxData = {"state" : "COMPLETE", "src" : src, "dst" : dst, "callId" : call.id, 'end' : nowTimestampUnix, 'duration' : call.timeOfCall }
			if( pCall.localHangup != undefined && pCall.localHangup == true )
			{
				// local call completed
				this.log('local call completed');
			}
			else
			{
				// remote call completed
				this.log('remote call completed');
			}
		}
		else if( call.state == "BUSY" )
		{
			this.log('call busy');
			ajaxData = {"state" : "BUSY", "src" : src, "dst" : dst, "callId" : call.id, 'end' : nowTimestampUnix }
		}
		else
		{
			this.log('unhandled');
			return;
		}


		if(ajaxData != false)
		{

			//suppress logging of Feature code calls
			if( ajaxData.dst.indexOf("tel:*") == 0 || ajaxData.dst.indexOf("tel:#") == 0 )
				return

			ajaxData.itemtype = "call"
			this.log("*******************About to log Call to UCDB: ")
			this.log(ajaxData)
			$.ajax({
				url: appBaseUrl + "/api/unify/ucdbput",
				method: 'POST',
				dataType: 'json',
				data : ajaxData,
				cache: false,
				success: function(response, type) {}
			})

		}

	}

	//callback to the ui then outbound call has been initiated
	$phone.outboundCallingUICallback = function( called, resultCode, resultEnglish )
	{

		//TODO: if result code is 1 (fail) then give notice and show appropriate buttons
		if( resultCode == 1 )
		{
			//$('#retryButton', "#dialog-phone").show();
		}
		else
		{
//			$('#hangupButton', "#dialog-phone").show();
		}

	}

	$phone.canceledUICallback = function(call) //by local or remote
	{
		//for now cancel just hides all
//		$("#dialog-phone").dialog("close");
	}

	$phone.rejectedUICallback = function( reason )
	{
//		$('.phoneCallStatus', "#dialog-phone").html('Call failed: ' + reason )
//		$('#retryButton', "#dialog-phone").show()
//		$('#dialpadButton', "#dialog-phone").hide()
	}

	$phone.localHeldUICallback = function(call) //held locally callback
	{
		//TODO: handle which call is actually being placed on hold
//		$('.phoneCallStatus', "#dialog-phone").html('Call on hold.')
//		$('#holdButton', "#dialog-phone").hide()
//		$('#retrieveButton', "#dialog-phone").show()
	}

	$phone.localRetrievedUICallback = function(call) //retrieved locally callback
	{
//		$('.phoneCallStatus', "#dialog-phone").html('In Call.')
//		$('#holdButton', "#dialog-phone").show()
//		$('#retrieveButton', "#dialog-phone").hide()
	}

	$phone.remoteHeldUICallback = function(call)
	{
//		$('.phoneCallStatus', "#dialog-phone").html( 'Call on hold by remote party.' )
	}

	$phone.remoteRetrievedUICallback = function(call)
	{
//		$('.phoneCallStatus', "#dialog-phone").html('In call.')
	}

//INBOUND

	$phone.inboundRingingUICallback = function(call)
	{
		callObject = {
			'ignore' : function() {
				$phone.hangup()
				$phone.closeToaster()
				if(getSelectedCallFolder() == 'CDR') 
				{
					$phone.refreshLog('CDR')
				}
			},

			'answer' : function() {
				$phone.answer()
				$("#nav").tabs("select",0)
				$phone.closeToaster()
				if(getSelectedCallFolder() == 'CDR')
				{
					$phone.refreshLog('CDR')
				}
			},

			'busy'	: function() {
				$phone.hangup()
				$phone.closeToaster()
			},

			'callInfo'	: call
		}

		$phone.popIncomingCallCallback(callObject)
	}

	$phone.missedCallUICallback = function(call) //inbound call not answered
	{
		//hide irrelevant buttons
		//show missed call.
		//$('.phoneCallStatus', "#dialog-phone").html("Missed call.")
		//$('.answerButton', "#dialog-phone").hide()
		//$('.busyButton', "#dialog-phone").hide()
		//$('.ignoreButton', "#dialog-phone").hide()
		$( ".callNotifyIncoming" ).dialog("close")
		closeToaster()
		$phone.notifyUIOfMissedCall()

		if(getSelectedCallFolder() == 'CDR' ) {
			setTimeout(function() {
					$phone.refreshLog('CDR');
				}, 1000);
		}
	}

	$phone.notifyUnhandledUICallback = function(state)
	{

		$phone.log('UI callback handler for unhandled/unredirected notifyUICallback(' + state + ')')

	}


/*********************************************************************************
Basic connectivity and initialization methods
*********************************************************************************/

	$phone.connectedUICallback = function()
	{

		$('#miniNewCallButton').attr('title', 'Connected to RTMP server')

	}

	$phone.connectionLostUICallback = function()
	{

		$('#miniNewCallButton').attr('title', 'Lost connection to RTMP server')

	}

	$phone.registeredUICallback = function()
	{

		$('#miniNewCallButton').attr('title', 'Registered with SIP server')
	}

	$phone.registerRequiredUICallback = function(required)
	{

		if( required )
			$('#miniNewCallButton').attr('title', 'Failed registering with SIP server')

	}

	$phone.put4GLabel = function(is4G)
	{
		if( is4G )
			$(".callStatus4G").addClass('On4G').attr('title', 'Yes! You are on your 4G network. Enjoy optimum voice quality with your network.')
		else
			$(".callStatus4G").removeClass("On4G").attr('title', 'Looks like you are not on the 4G network. Your voice quality may not be optimal.')
	}

	$phone.isOn4GNet = function()
	{

		// 255.255.0.0 to 255.255.0.1 are 4G addresses
		function ipToInt(s)
		{
			s = s.split('.');
			return s[0]*255*255*255 + s[1]*255*255 + s[2]*255 + s[3];
		}
		var intIP = ipToInt(clientIP);
		return (intIP >= ipToInt('255.255.0.0') && intIP <= ipToInt('255.255.0.1') );


	}

	$phone.notifyUIDetect4GNetwork = function()
	{

		is4G = this.isOn4GNet()
		this.log('clientIP=' + clientIP + ', is4G=' + is4G)
		$phone.put4GLabel(is4G)
	}


/********************************************************************************
Misc. methods
*********************************************************************************/


	$phone.showSettingsUICallback = function(event)
	{

		$('#phoneSettingsDialog').dialog("open");
		offset = $('.phoneFrameLower', '#phoneSettingsDialog').offset()
		$('#phone1').css('right', null )
		$('#phone1').css('left', parseInt(offset.left-8) + 'px')
		$('#phone1').css('top', parseInt(offset.top+62) + 'px')
		this.showFlashStageWrapper()
		this.params.flashConnectorHandle.viewAccessMessage();

	}

	$phone.showFlashStageWrapper = function()
	{

		//this.log( 'webphone.phtml #1023: showFlashStageWrapper' )

		if(!$.browser.msie) {
			$('.phone1FlashWrapper').css("display", "visible");  // fake hide here do not use $.hide()
		}

		$('.phone1FlashWrapper').css("width", "215px")
		$('.phone1FlashWrapper').css("height", "137px")

		if(!$.browser.msie) {
			$('#phone1FlashObject').attr("style", "visibility:visible;") // fake hide here do not use $.hide()
		}

	}

	$phone.hideFlashStageWrapper = function()
	{

		if(!$.browser.msie) {
			$('.phone1FlashWrapper').css('display','hidden');  // fake hide here do not use $.hide()
		}

		$('.phone1FlashWrapper').css("height", "10px")
		$('.phone1FlashWrapper').css("top", "-5px")

		if( !$.browser.msie )
			$("#phone1FlashObject").attr("style", "visibility:hidden;")  // fake hide here do not use $.hide()
		
		if( isFirstLogin() )
			setTimeout( function() { $('.help-tooltip[tabname=mail]').click() },3000 )

	}
	//$phone.hideFlashStageWrapper()

	$phone.errorUICallback = function( error )
	{

		$phone.log( 'Error: ' + error )

		// update credential
		if( $phone.testingNewSIPAccount === true )
		{
			VerifySipAccountCallback(false);
		}

	}

	$phone.resetPhoneDialog = function()
	{

		//only use this if you are certain you are not going to mess up a call held state etc.
		//use this to totally reset the phone dialog to initial state
//		$("#dialog-phone").attr("class", "ui-dialog-content ui-widget-content")
//		$('.phoneButton', "#dialog-phone").hide()

	}

	$phone.closeToaster = function()
	{
		closeToaster();
	}

	$phone.getNewContactFlag = function(flag)
	{
		return $('.call-detail', '.call-connected').attr('newContactFlag')
	}

	$phone.setNewContactFlag = function(flag)
	{
		flag? $('.call-detail', '.call-connected').attr('newContactFlag', true) : $('.call-detail', '.call-connected').attr('newContactFlag', '')
	}

	$phone.searchForContact = function(searchString, callInfo, callback)
	{

		this.log("searching contact ["+ searchString +"]");
		$.ajax({
			url: moduleBaseUrl + "/contacts/whois/search/" + encodeURIComponent(searchString),
			method: 'GET',
			dataType: 'json',
			success: function(data, type) { callback(callInfo,data) }
		})
	}

	$phone.existContact = function(contactInfo)
	{
		// detect whether already exists
		existContact = false;

		$.ajax({
			async: false,
			url: moduleBaseUrl + "/contacts/whois/search/" + contactInfo,
			method: 'GET',
			dataType: 'json',
			success: function(data, type)
			{
				if( data.result == 'found') {
					existContact = true;
				}
			}
		})

		return existContact
	}

	$phone.addToContacts = function(contactInfo)
	{

		if(!contactInfo || contactInfo == 'Unknown')
			return;

		if(contactInfo.indexOf(',') >= 0 )
		{
			alert('You cannot add group of contacts or a contact containing illegal character(s)!')
			return
		}

		contactInfo = $phone.humanize(contactInfo)
		this.log("Adding to contact")
		this.log(contactInfo)

		if( this.existContact(contactInfo) )
		{
			alert("Contact already exists")
			return;
		}

		$("#newContactButton").click()
		var update_contact_field = function(contactInfo, count)
		{

			$userNumber1 = $('input#Phone:first');
			if( $userNumber1.length>0 )
			{

				if(!isNaN(contactInfo-0))  // is a number
					$userNumber1.removeClass("default").val(contactInfo);
				else
					$('input#SIP:first').removeClass("default").val(contactInfo);
				clearInterval($phone.intervalId);

			}
			else if(count>20)
				clearInterval($phone.intervalId);

		}
		count = 0;
		$phone.intervalId = setInterval( function(){	update_contact_field(contactInfo, ++count) }, 500);

	}

	$phone.deviceName = function( dbDeviceValue )
	{
		
		var device_name = {
			'UserHomePhone'		: 'Home Phone',
			'UserHomeMobile'	: 'Home Mobile',
			'UserHomeFax'		: 'Home Fax',
			'UserWorkPhone'		: 'Work Phone',
			'UserWorkMobile'	: 'Work Mobile',
			'UserWorkFax'		: 'Work Fax',
			'SIP'				: '',
			'Unknown'			: ''
		}
		dbDeviceValue = $.trim(dbDeviceValue.split(",")[0])
		return device_name[dbDeviceValue] ? device_name[dbDeviceValue] : ''
		
	}

	$phone.makeDetailHeaderInternal = function(row)
	{
		var outbound = isOutbound( row.src );
		var contactNamesArray = ( outbound ? row.target_name : row.source_name).split(",");
		var contactDevice = $phone.deviceName( outbound ? row.target_device : row.source_device );
		var contactRawNumbers = outbound ? row.dst : row.src
		var contactNumbersHumanArray = $phone.humanize( contactRawNumbers ).split(',');

		//var contactNumberHuman = contactNumbersHumanArray[0]

		var spaceCharacter = "&nbsp;"
		
		if( contactNamesArray[0] == 'Unknown' ) 
			contactNamesArray[0] = contactNumbersHumanArray[0]

		//var SMSDetailsHeader = "";

		//drop showing device names if multiple contacts (too cluttered)
		//if( contactNamesArray.length == 1)
		//	contactDevice = ""
		
		contactNamesArray && ( SMSDetailsHeader += contactNamesArray.join(","+ spaceCharacter) + contactDevice )
		
		var title = contactNumbersHumanArray.join(", ")
		var SMSDetailsHeader = contactNamesArray[0] + spaceCharacter + contactDevice
		
		if( contactNumbersHumanArray.length > 1 ) 
			SMSDetailsHeader += ', and ' + (contactNumbersHumanArray.length-1) + ' more'
		
		return [SMSDetailsHeader, title]
		
	}

	$phone.makeDetailHeader = function(row)
	{
		return $phone.makeDetailHeaderInternal(row)[0]
	}

	$phone.makeDetailHeaderTitle = function(row)
	{
		return $phone.makeDetailHeaderInternal(row)[1]
	}

	$.cookie = function(key, value, options) 
	{

		// key and at least value given, set cookie...
		if (arguments.length > 1 && (!/Object/.test(Object.prototype.toString.call(value)) || value === null || value === undefined)) 
		{
			options = $.extend({}, options);

			if (value === null || value === undefined) 
			{
				options.expires = -1;
			}

			if (typeof options.expires === 'number') 
			{
				var days = options.expires, t = options.expires = new Date();
				t.setDate(t.getDate() + days);
			}

			value = String(value);

			return (document.cookie = [
				encodeURIComponent(key), '=', options.raw ? value : encodeURIComponent(value),
				options.expires ? '; expires=' + options.expires.toUTCString() : '', // use expires attribute, max-age is not supported by IE
				options.path ? '; path=' + options.path : '',
				options.domain ? '; domain=' + options.domain : '',
				options.secure ? '; secure' : ''
			].join(''));
		}

		// key and possibly options given, get cookie...
		options = value || {};
		var decode = options.raw ? function(s) { return s; } : decodeURIComponent;

		var pairs = document.cookie.split('; ');
		for (var i = 0, pair; pair = pairs[i] && pairs[i].split('='); i++) 
		{
			if (decode(pair[0]) === key) return decode(pair[1] || ''); // IE saves cookies with empty string as "c; ", e.g. without "=" as opposed to EOMB, thus pair[1] may be undefined
		}
		return null;
	}
	
	$('#miniNewCallButton').bind('click', function() { $phone.newCall() });
	
	$(".jsServiceProvider").unbind('click').bind('click', function(e) 
	{

		$("#nav").tabs("select",0)
		$("#navMessages").tabs("select",0)
		e.preventDefault()
		e.stopPropagation()
		// Make this folder list node selected
		$("DIV.current", "#Email").removeClass('current');
		$(this).parent().addClass('current');

		//reload CSS, template and show templateDummy (used for dev)

		if( e.altKey == true || e.shiftKey == true )
		{
			$('#Email #primary #messageList').empty();
			//reload CSS
			_e = e
			$.ajax({
				accepts : "text/html",
				contentType : "text/html",
				type:"POST",
				url : siteBaseUrl + "index.php/mail/service/reloadtemplate/template/templateSMS",
				dataType: "html",
				async:false,
				cache: false,
				success: function(html) { $("#templateSMS").html(html); if( _e.altKey == true ) $("#Email #primary #messageList").html( $("#templateSMSMain").clone().removeAttr("id").html() ); }
			})
			if( e.altKey == true )
				return false
		}

		var folder = $(this).attr('folder') || undefined

		if( folder == "SMS" || folder == "CDR" )
		{
			//$('#Email #primary #messageList').showPanel(dataSourceURL,dataSourceParams, $.localData.dataStore["pid"+pid].folders[folder], $.templateEngine.templates.SIP[folder] )
			$phone.refreshLog(folder)
			$phone.clearUIOfMissedCall()
		}
		else
		{

			var dataSourceURL = $(this).attr('href')
			var pid = $(this).attr('pid')
			var myId = $(this).attr('myid')
			var myDisplayName = $(this).attr('mydisplayname')
			var folder = $(this).attr('folder') || undefined
			var serviceType = $(this).attr('servicetype') || undefined
			var serviceName = $(this).attr('servicename') || undefined
			var serviceDesription = $(this).attr('servicedesription') || undefined

			//TODO add ability to detect folder and other args our of the url (makes DOM coding simpler)
			var dataSourceParams = {
				"pid" : pid,
				"serviceType" : serviceType,
				"serviceName" : serviceName,
				"serviceDesription" : serviceDesription,
				"myId" : myId,
				"myDisplayName" : myDisplayName,
				"folder" : folder, //first folder to make sure present and return prepared with parent tree
				"limit" : "50",
				"dataSourceURL" : dataSourceURL
			}
			$.localData.checkProviderStoreReady(dataSourceParams)
			$('#Email #primary #messageList').showPanel(dataSourceURL,dataSourceParams, $.localData.dataStore["pid"+pid].folders[folder])

		}

		updateNaviToolBar(folder)

		return false

	})
	
	$phone.showMiniDial = function()
	{

		$(".call-connected").hide()
		$(".incoming-call").hide()
		//$(".call-dialpad").hide()
		//$(".call-dialpad").css("bottom", "-140")
		$(".phoneMiniDial").show()
		$(".phoneMiniDial").css("background-position","0 -6px");

		$(".makeACall", ".phoneMiniDial").css("visibility","hidden")
		$(".callQuality", ".phoneMiniDial").css("visibility","hidden")
		$(".buttonDialpadShowHide", ".phoneMiniDial").css("visibility","hidden")
		$(".mini-drop", ".phoneMiniDial").css("visibility","hidden")
		$('.dialpad-numberpad',".call-dialpad").hide()
		$('.phoneMiniDialInput',".call-dialpad").hide()
		$('.phoneMiniDialButton',".call-dialpad").hide()
		$(".call-dialpad").animate({"bottom":"-140"}, 120, null, function()
		{

			$(".call-dialpad").hide()
			$(".phoneMiniDial").css("background-position","")
			$(".makeACall", ".phoneMiniDial").css("visibility","")
			$(".callQuality", ".phoneMiniDial").css("visibility","")
			$(".buttonDialpadShowHide", ".phoneMiniDial").css("visibility","")
			$(".mini-drop", ".phoneMiniDial").css("visibility","")


		})


		$(".phoneOptions").hide()

		$("#Email #secondary").css("margin-bottom","95px")

		$phone.savePadPosition(null)
	}

	$phone.showInlineIncomingCall = function()																												//shows if on email tab
	{

		$(".call-connected").hide()
		$(".call-dialpad").hide()
		$(".phoneOptions").hide()
		$(".phoneMiniDial").hide()
		$(".incoming-call").show()

		$("#Email #secondary").css("margin-bottom","179px")

	}

	$phone.showDialogIncomingCall = function()																												//shows if not on email tab
	{


	}

	$phone.showCallDetails = function()
	{

		$(".call-dialpad").hide()
		$(".phoneOptions").hide()
		$(".phoneMiniDial").hide()
		$(".incoming-call").hide()
		$(".call-connected").show()

		$("#Email #secondary").css("margin-bottom", "246px")

		if ($('.phoneRemoteName').is(':empty'))
		{
			$(".closeButtonUnit").removeClass("contactExists");
	    }
		else {
			$(".closeButtonUnit").addClass("contactExists");
		}

		$(".abookButtonUnit", ".call-connected").hide()
		$(".closeButtonUnit", ".call-connected").show()

	}

	$phone.showRedialPad = function()
	{
		$(".closeButtonUnit", ".call-connected").hide()

		var contact = $('.caller-details > .phoneRemoteNumber', '.call-connected').text()
		var $closeButton = $('.buttonClose','.call-connected')

		$closeButton.unbind().bind('click', function(){
			$(".abookButtonUnit", ".call-connected").hide()
			$(".closeButtonUnit", ".call-connected").show()

			$phone.showMiniDial()
		})

		$('.buttonRedial','.call-connected').unbind().bind('click', function(){
			$closeButton.click()
			contact && $phone.initiateOutboundUICall(contact)
		})

		var $addButton = $('.buttonAddContact','.call-connected')

		if( $phone.getNewContactFlag() )
		{
			$addButton.unbind().bind('click', function(){
				$closeButton.click()

				$phone.showMiniDial()
				contact && $phone.addToContacts(contact)
			})

			$addButton.show()
		}
		else
		{
			$addButton.hide()
		}

		$(".abookButtonUnit", ".call-connected").show()

		if($(".buttonAddContact").css('display') == 'none')
		{
	        $(".abookButtonUnit").addClass("contactExists");
	    }
		else
		{
			$(".abookButtonUnit").removeClass("contactExists");
			$(".abookButtonUnit").addClass("addContact");
			$(".phoneRemoteNumber").addClass("addContact");
		}

	}

	$phone.showQualityDisplay = function()
	{

		var quality = networkQuality();

		$('.callQuality').attr("class",quality);

		if(quality == 'excellent') {
			$('.callQuality').attr("title", "Connection speed is fast. Call quality should be excellent.");
		} else if(quality == 'good') {
			$('.callQuality').attr("title", "Connection speed is OK. Call quality should be good");
		} else if(quality == 'poor') {
			$('.callQuality').attr("title", "Connection speed is slow. Call quality might be affected.");
		} else if(quality == 'no-connection') {
			$('.callQuality').attr("title", "No connection. You will not be able to make a call");
		}

	}

	$phone.lostRTMPConnectionUICallback = function()
	{

		if($phone.getCurrentCall())
		{

			$phone.localHungupUICallback();
			$phone.currentCalls = [];

		}

		$phone.showMiniDial();
		$('.phoneMiniDialButton','#Email').attr('disabled','true').css('opacity','0.5');
		$('.callQuality', '#Email').css('opacity','0.2');

		//wait 10 seconds then try fetch something, if fetch fails then alert.
		setTimeout( function(){ var tmpImage = new Image(); tmpImage.onerror = function() { alert("Internet connection lost."); }; tmpImage.src = siteBaseUrl + "images/paging.jpg?fresh=" + (new Date().getTime()); }, 10000);

	}

	$phone.LostInternetTimer = function()
	{



	}

	$phone.showDialpad = function()
	{
		$phone.showQualityDisplay();
		$('.dialpad-numberpad',".call-dialpad").show()
		$('.phoneMiniDialInput',".call-dialpad").show()
		$('.phoneMiniDialButton',".call-dialpad").show()
		$(".phoneOptions").hide()
		$(".phoneMiniDial").hide()
		$(".incoming-call").hide()
		$(".call-connected").hide()
		$(".call-dialpad").show()
		$(".call-dialpad").animate({"bottom":"3"}, function()
		{
			$("#Email #secondary").css("margin-bottom","246px")
		})


		$phone.savePadPosition(true)
	}

	$phone.savePadPosition = function(status)
	{
		$.cookie("show-full-pad", status)
	}

	$phone.getPadPosition = function()
	{
		return $.cookie("show-full-pad");
	}

	if($phone.getPadPosition()) {
		setTimeout(function(){
			$(".buttonDialpadShowHide", ".phoneMiniDial").click();
		}, 500)
	}

	$(".buttonDialpadShowHide", ".phoneMiniDial").unbind().bind("click", function() 																					//show dialpad with input to make a new call
	{

		$(".phoneMiniDialInput", ".call-dialpad").attr("value", $(".phoneMiniDialInput", ".phoneMiniDial").attr("value") )

		$(".call-dialpadDetails", ".call-dialpad").hide()
		$(".call-dialpadButtons", ".call-dialpad").hide()
		$(".dialerInputPanel", ".call-dialpad").show()
		$phone.showDialpad()

	})

	$(".buttonDialpadShowHide", ".call-connected").unbind().bind("click", function()
	{
		//if dialpad button pressed from call-connected panel, and in call then show dialpad with call info, alse whoe input for new call
		if( $phone.getCurrentlyTalkingCall() == null )
		{

			$(".call-dialpadDetails", ".call-dialpad").hide()
			$(".call-dialpadButtons", ".call-dialpad").hide()
			$(".call-dialpadDialInput", ".call-dialpad").show()

		}
		else
		{

			var phoneRemoteName = $(".phoneRemoteName", ".call-connected").html()
			var phoneRemoteNumber = $(".phoneRemoteNumber", ".call-connected").html()
			//var currentCallTime = $(".phoneTimer .countdown_amount", ".call-connected").html()
			//$(".phoneTimer", ".call-dialpad").countdown({since: "-"+currentCallTime, compact: true, format: 'hmS', description: ''}).countdown('change', {since: "-"+currentCallTime})
			$(".phoneRemoteName", ".call-dialpad").html(phoneRemoteName)
			$(".phoneRemoteNumber", ".call-dialpad").html(phoneRemoteNumber)
			$(".call-dialpadDialInput", ".call-dialpad").hide()
			$(".call-dialpadButtons", ".call-dialpad").show()
			$(".call-dialpadDetails", ".call-dialpad").show()
			$(".call-dialpad").css({'height' : '231px', 'padding-top' : '11px'});
			$(".dialpad-numberpad").css("top","12px");
		}
		$phone.showDialpad()

	})

	$(".buttonDialpadShowHide", ".call-dialpad").unbind().bind("click", function(e)
	{

		if( $phone.getCurrentCalls().length == 0 )
		{
			$(".phoneMiniDialInput", ".phoneMiniDial").attr("value", $(".phoneMiniDialInput", ".call-dialpad").attr("value") )
			$phone.showMiniDial()

			$phone.showQualityDisplay();
			//$('.callQuality').attr("src", siteBaseUrl + "images/webphone/" + networkQuality() + ".png" );

		}
		else
			$phone.showCallDetails()

	})


	//Dialpad keyboard shortcuts
	$('.phoneDialInput', ".call-dialpad").bind('keydown', function(e)
	{

		if( e.which == 13 )
		{
			$('.phoneDialButton', ".call-dialpad").trigger('click');
			e.preventDefault();
		}

	})

	$('.phoneMiniDialInput', ".phoneMiniDial").bind('keydown', function(e)
	{

		if( e.which == 13 && !$(".ac_results").is(':visible') )
		{
			$('.phoneMiniDialButton', ".phoneMiniDial").trigger('click');
			e.preventDefault();
		}

	})

	//minidialer keyboard shortcuts
	$('.phoneMiniDialInput', ".call-dialpad").bind('keydown', function(e)
	{

		if( e.which == 13 )
		{
			$('.phoneMiniDialButton', ".call-dialpad").trigger('click');
			e.preventDefault();
		}

	})

	//var data = [ {text:'Link A', value:'/page1'}, {text:'Link B', value: '/page2'} ];
	$( ".phoneMiniDialInput" ).autocomplete( moduleBaseUrl + "/contacts/autocomplete/need/voice/limit/50",
	{
		whereamiused: "dialerAutocomplete",
		selectFirst: false,
		//highlight: false,
		//onlyFromValues: false,
		width: "210px",
		formatItem : function(item) { return item[3]; }, //dropdown
		formatResult : function(item) { return item[0]; }, //formval
		parse : function(data)
		{
			var parsed = [];
			var rows = data
			for (var i=0; i < rows.length; i++)
			{
				var row = rows[i];
				parsed[parsed.length] = {
					data: row,
					text: row[3],
					value: row[0],
					result: this.formatResult && this.formatResult(row, row[3]) || row[3]
				}
			}
			return parsed;
		},
		dataType: "json"
	})//.result( function(event, item) { $(this).parent().find(".phoneMiniDialButton").trigger("click") });

	$('.phoneMiniDialButton', ".phoneMiniDial").unbind().bind('click', function()
	{
		if($(this).attr('disabled')==='true') return;

		//change class to layout for pendingCallOutbound view
		$phone.params.uiMainMode = "pendingCallOutbound"
		called = $.trim( $(".phoneMiniDialInput", ".phoneMiniDial").attr("value") )
		if(called.length<2) return
		$phone.initiateOutboundUICall(called)
	})

	$phone.setWimax = function(is)
	{

		if(is)
		{

			//this.forceClientCodec("speex16");
			//this.setProperty("user_agent","Atmailphone-WiMax");
			//this.setProperty("codecs","speex16,g729,alaw,ulaw,h263,telephone-event");
			//this.setProperty("codecs","speex16,ulaw,alaw,g729,telephone-event");
			//this.setProperty("codecs","ulaw,alaw,speex16,g729,telephone-event");
			//this.setSpeexQuality(7);
			//this.setJitterBufferEnabled(true);
			//this.log( 'indexfolderlist.phtml #1079: Configuring local client for Wi-Max network:' )

		}
		else
		{

			//this.forceClientCodec("default");
			//this.setProperty("user_agent","Atmailphone-Wire");
			//this.setProperty("codecs","speex16,g729,alaw,ulaw,h263,telephone-event");
			//this.setProperty("codecs","ulaw,alaw,speex16,g729,h263,telephone-event");
			//this.log( 'indexfolderlist.phtml #1089: Configuring local client for non-Wi-Max network:' )

		}

	}

	$phone.SIPLoginSuccessUICallback = function(sipObject)
	{
		// update credential
		if( $phone.testingNewSIPAccount === true )
		{
			VerifySipAccountCallback(true);
		}

		this.log( 'phoneUI.js #1589: SIPLoginSuccessUICallback' )
		$('.phoneMiniDialButton','#Email').removeAttr('disabled').css('opacity','1.0');
		$('.callQuality', '#Email').css('opacity','1.0');

		var phoneNumbers = sipObject.message.raw.match(/<tel:(\d*)>/);

		if(phoneNumbers && phoneNumbers.length>1) 
			var phoneNumber = phoneNumbers[1];
		else
			var phoneNumber = phoneNumbers
			
		$phone.params.phoneNumber = phoneNumber;
		
		$.php( moduleBaseUrl + '/Service/update/number/' + urlencode($phone.params.phoneNumber));
		$('#sip_folder_title_phonenumber').text($phone.params.phoneNumber);

		$phone.showQualityDisplay();
		//$('.callQuality').attr("src", siteBaseUrl + "images/webphone/" + networkQuality() + ".png" )
		$phone.notifyUIDetect4GNetwork()

		//if( true || $phone.isOn4GNet() )
		$phone.setWimax(true) //force to true for all so that only speex used on flash player
		//else
		//	$phone.setWimax(false)

		//this.params.flashConnectorHandle.setMicVolume(this.params.micVolume)
		//this.hideFlashStageWrapper();
		//this.setMicVolume(this.params.micVolume)
		this.setSpeakerVolume(this.params.speakerVolume)

		//this.params.flashConnectorHandle.setAgcPolicy("min_level=20,max_level=80,agressive_down=1.2,agressive_up=1.0001,ema_alpha=0.5,gain_level=8,max_gain=90,min_gain=70,trace=false");

		//substribe to be notified about sip session termination (someone else logged in)

		//this.log('SIPType=' + $phone.sipMode())

		if( $phone.sipMode() == 'SAMSUNG' )
		{
			$phone.checkForMessages()
			this.params.flashConnectorHandle.subscribe({"event":"reg", "expires": 3600, "status": "ACTIVE"})
		}

		if( $phone.params.flashConnectorHandle.isMuted() == 1 )
			$phone.showSettingsUICallback();
		else
		{

			//this.hideFlashStageWrapper()
			if( isFirstLogin() )
				setTimeout(function() { $('.help-tooltip[tabname=mail]').click() },3000 )

		}


	}

	$phone.checkForMessages = function()
	{

		//check for undelivered SMS messages
		//first make an xcap call to see if there are any messages waiting and only call sip:Deferred iff there are messages waiting
		this.log("Checking if there are any deferred SMSs waiting to be fetched.")
		this.sendXcapRequest()

	}

	$phone.notifyXcapResponseUICallback = function(body)
	{


		//here is the response indicates that there are messages waiting then we will call Deferred to fetch them.
		//fetch undelivered SMS messages.
		if( body.indexOf("history-reference") != -1 )
		{

			this.log("Deferred SMSs waiting, so fetching them.")
			this.params.flashConnectorHandle.call("sip:Deferred@myimsserver.com", 'Caller');

		}

	}

	$phone.initiateOutboundUICall = function(called)
	{
		
		//this.log("raw called: " + called)
		if(called.indexOf(',') > 0) 
		{

			alert('Can not call a group')
			return;
		
		}

		//basic dialstring charset enforcement
		called = called.replace(/[^0-9A-Za-z\#\*\+\-\_\@\.\:]/g, '');
		//this.log("basic called: " + called)

		//prevent dialing second number if already in a call
		if( !($phone.getCurrentCall() == undefined || $phone.getCurrentCall() == null) )
			return


		if(!called) 
		{
		
			alert('No call number specified!');
			return;
		
		}

		if( $(".phoneMiniDialButton:last").hasClass("disabled") )
		{

			alert("Unable to place call. Webphone has been logged out because another device using this account has logged in.");
			return

		}

		calledHumanized = $phone.humanize(called.toLowerCase())
		//change class to layout for pendingCallOutbound view
		$phone.params.uiMainMode = "pendingCallOutbound"
        $('.phoneTimer', '#secondary').html("00");
		$('.phoneRemoteImg', '.call-connected').attr('src', siteBaseUrl + 'images/themes/' + $phone.params.cssStyleTheme + '/contact-photo.png' )
		$('.phoneRemoteName', '.call-connected').html('')
		$('.phoneRemoteNumber', '.call-connected').html( calledHumanized )
		$('.phoneCallStatus', '.call-connected').html( 'Dialing...' )
		$('.phoneCallStatus2', '.call-connected').html( '' )
		$('.phoneCallStatus2', '.call-connected').hide()
		countdownDestroy()

		$phone.showCallDetails()
		$phone.setNewContactFlag(false)

		calledSIPURIbasic = $phone.getBasicSIPURIFromRawInput(called)
		if( calledSIPURIbasic == "tel:112" || calledSIPURIbasic == "tel:999" || calledSIPURIbasic == "tel:991" || calledSIPURIbasic == "tel:994" || calledSIPURIbasic == "tel:333"  )
		{

			$('.phoneRemoteName', '.call-connected').html('<b>Emergency Number</b>' )

		}
		else
		{
			//TODO search must cleanup numbers in order to accurately match between contacts (user stored format) and dialed string (user entered format)
			$.ajax({
				url: moduleBaseUrl + "/contacts/whois/search/" + calledHumanized,
				method: 'GET',
				dataType: 'json',
				success: function(data, type)
				{
					updateContactFromAbook(data, calledHumanized)
				}
	        });
		}

		$phone.callQualityTimer = setInterval( function() {
			//$('.callQuality').attr("src", siteBaseUrl + "images/webphone/" + networkQuality() + ".png" );
			$phone.showQualityDisplay();
			}, 10000)
		$("#nav").tabs("select",0)
		$("#navMessages").tabs("select",0)

		$phone.call( calledSIPURIbasic )
		$(".closeButtonUnit", ".call-connected").show()
		$(".abookButtonUnit", ".call-connected").hide()

		$(".buttonEnd", "#secondary").each(function(){
			$(this).attr('disabled','true').css('opacity','0.5');
		});

		setTimeout(function() {
			$(".buttonEnd", "#secondary").each(function(){
				$(this).attr('disabled','').css('opacity','1.0');
			});
		}, 3000);

	}

	$phone.notifyUISIPAccountLoggedOut = function()
	{

		$(".phoneMiniDialButton").addClass("disabled")
		window.location = appBaseUrl + "/default/index/sessiontimeout"
		//alert("Another device has logged in with this account. This session will now be logged out.");

	}

	$('.phoneMiniDialButton', ".call-dialpad").unbind().bind('click', function()
	{
		if($(this).attr('disabled')==='true') return;
		called = $.trim( $(".phoneMiniDialInput", ".call-dialpad").attr("value") )
		if(called.length<3) return
		$phone.initiateOutboundUICall(called)

	})

	$(".buttonEnd", ".call-connected").unbind().bind("click", function()
	{
		if( $(this).attr('disabled') == 'true' ) return;
		$phone.hangupAll()
	})

	$(".buttonClose", ".call-connected").unbind().bind("click", function()
	{

		if( $phone.callQualityTimer != null )
			clearInterval($phone.callQualityTimer)
		$phone.localHungupUICallback()

	})

	$(".buttonHoldRetrieve", ".call-connected").unbind().bind("click", function() {

		if( $(this).attr("held") == "false" )
		{

			$phone.hold()
			$(this).attr("value", "Retrieve")
			$(this).attr("held","true")
			$('.phoneCallStatus', '.call-connected').html( 'On hold.' )

		}
		else
		{

			$phone.retrieve()
			$(this).attr("value", "Hold")
			$(this).attr("held","false")
			$('.phoneCallStatus', '.call-connected').html( 'In call' )

		}

	})

	$(".buttonMuteUnmute", ".call-connected").unbind().bind("click", function()
	{
		var callObj = $phone.params.flashConnectorHandle.getCurrentCall();
		if(!callObj || callObj.state!='TALK') return;

		if( $(this).attr("muted") == "false" )
		{

			$phone.muteUnmute(true)
			$(this).attr("muted","true")
			$(this).addClass("UnMute")
			//$("a span strong", $(this)).html("Unmute") //TODO: Mik CSS TLC
			$('.phoneCallStatus', '.call-connected').html( 'Muted' )
			$(this).find('strong').html('Unmute')

		}
		else
		{

			$phone.muteUnmute(false)
			$(this).attr("muted","false")
			$(this).removeClass("UnMute")
			//$("a span strong", $(this)).html("Mute")
			$('.phoneCallStatus', '.call-connected').html( 'In call' )
			$(this).find('strong').html('Mute')

		}

	})

	$(".buttonTransferPrep", ".call-connected").unbind().bind("click", function()
	{
		$(".jsTransfer", ".call-connected").show()
		$(".buttonTransfer", ".call-connected").show()
	})

	$(".phoneTransferInput", ".call-connected").bind('keypress', function(e)
	{

		if( e.which == 13 )
		{
			$(".phoneTransfer", ".call-connected").trigger('click');
			e.preventDefault();
		}

	})

	$(".buttonTransfer", ".call-connected").unbind().bind("click", function()
	{

		$(".jsTransfer", ".call-connected").hide()
		$phone.transfer( $phone.getBasicSIPURIFromRawInput($(".phoneTransferInput", ".call-connected").attr("value")) )
		$(".phoneTransferInput", ".call-connected").attr("value","")

	})

	$(".buttonTransferCancel", ".call-connected").unbind().bind("click", function()
	{

		$(".jsTransfer", ".call-connected").hide()

	})

	$(".buttonClose", ".call-connected").unbind().bind("click", function() 																					//only visible after a hangup
	{

		$phone.showMiniDial()

	})

	$(".buttonEnd", ".call-dialpad").unbind().bind("click", function()
	{
		if( $(this).attr('disabled') == 'true' ) return;

		if( $phone.callQualityTimer != null )
			clearInterval($phone.callQualityTimer)
		$phone.hangup()
		$phone.localHungupUICallback()//call it immediately even although $phone will callback it once server finishes hangup

	})

	$(".buttonMuteUnmute", ".call-dialpad").unbind().bind("click", function()
	{
		var callObj = $phone.params.flashConnectorHandle.getCurrentCall();
		if(!callObj || callObj.state!='TALK') return;

		if( $(this).attr("muted") == "false" )
		{

			$phone.muteUnmute(true)
			$(this).attr("muted","true")
			$(this).addClass("UnMute")
			//$("a span strong", $(this)).html("Unmute")
			$('.callStatus', '.call-dialpad').html( 'Muted' )
			$(this).find('strong').html('Unmute')

		}
		else
		{

			$phone.muteUnmute(false)
			$(this).attr("muted","false")
			$(this).removeClass("UnMute")
			//$("a span strong", $(this)).html("Mute")
			$('.callStatus', '.call-dialpad').html( 'In call' )
			$(this).find('strong').html('Mute')

		}

	})

	$phone.getBasicSIPURIArrayFromRawInput = function( raw )
	{

		if( raw == undefined || raw.length == 0 )
		{

			//this.log("Bad input received for getBasicSIPURIArrayFromRawInput: ")
			//this.log(raw)
			return []

		}
		var recipientsInputArray = raw.split(/[,;]+/)
		var recipientsInputArrayFinal = []
		for (var i = 0; i < recipientsInputArray.length; i++)
		{
			
			if( recipientsInputArray[i].indexOf("phone-context=") == -1 )
				recipientsInputArrayFinal.push(this.getBasicSIPURIFromRawInput(recipientsInputArray[i]) );

		}
		return recipientsInputArrayFinal

	}
	$phone.getBasicSIPURIFromRawInput = function( raw )
	{

		//this.log('raw = ' + raw)
		if( !raw ) 
			return '';

		var basic = raw.split(/[;,]+/)[0] //firstly split off any parameters
		
		var prefix = null
		if( raw.indexOf("tel:") === 0 || raw.indexOf("sip:") === 0 )
		{
			prefix = raw.substring(0,4)
			basic = raw.substring(4)
		}
		
		//until we can arrive at more generic dialstring cleanup rules, lets just return exactly what the user dialed
		//this.log("basic = " + basic)
		var final = '';
		//US Numbers dialed as plain 1......
		if( basic.indexOf("+1") === 0 )
		{
			
			if( prefix == null )
				prefix = "tel:"
			basic = String(basic.replace(/[^\d]/g,""));
			
			
		}
		else if( basic.indexOf("+") === 0 ) //!US numbers dialed as 011countrycode......
		{
			
			if( prefix == null )
				prefix = "tel:"
			basic = String("011") + String(basic.replace(/[^\d]/g,""));
			
		}
		else if( basic.indexOf("+") === 0 || basic.indexOf("#") === 0 || basic.indexOf("*") === 0 )
		{

			if( prefix == null )
				prefix = "tel:"
			basic = basic.replace(/[^\d\+#\*]/g,"");

		}
		else if( !(/[a-zA-z@]/i.test(basic)) ) //does not contain any letters or @ //is a phone number so cleanup and prepend tel:
		{
			//looks like a phone number so set tel prefix if not set
			if( prefix == null )
				prefix = "tel:"
			basic = basic.replace(/[^\d\+#\*]/g,"")
			//if( basic.indexOf("00") === 0 ) //if starts with 00 then change to +
			//	basic = "+" + basic.substring(2)
			//else if( basic.charAt(0) === "0" ) //else if starts with 0 i.e. local number e.g. 061..., use as is (local country number)
			//	final = "tel:" + basic
			//else
			//	final = "tel:" + basic

		}
		else //must be a SIP address not a phone number
		{
			
			//nothing left to do with basic

		}
		if( prefix == null )
			prefix = "sip:"
		
		//dont append the prefix if generic (like Asterisk - Flashphoner <-> Asterisk with : causes issues without special FF plugin mentioned in the docs, so less problematic to just drop the prefix)
		if( this.params.SIPServerType == "SIP" && prefix == "tel:" )
			final = basic
		else
			final = prefix + basic
		
		return final

	}

	$phone.humanize = function(raw)
	{
		if(typeof(raw) != 'string')
		{
			return 'Unknown';
		}

		if( !raw || raw == 'Unknown' )
		{
			return "Unknown"
		}

		var rawArray = raw.split(/;/g)[0].split(/,/g) //firstly split off any parameters and then split by comma (multiple) //only Venezuela has commas in their phone number format

		finalArray = []
		for (var i = 0; i < rawArray.length; i++)
		{

			basic = $.trim(rawArray[i])
			//strip tel:/sip: off before trying to match
			if( basic.indexOf("tel:") === 0 || basic.indexOf("sip:") === 0 )
				basic = basic.substring(4)

			//humanize +60 to 0
			if( basic.indexOf("+60") === 0 )
				basic = basic.substring(2)

			finalArray[finalArray.length] = basic

		}
		return finalArray.join(", ")

	}

	$.prototype.getkeyPadInputFromEvent = function(e)
	{

		var x = e.pageX - $(this).offset().left;
		var y = e.pageY - $(this).offset().top;

		if( y < 32 ) // 1, 2, 3
		{

				 if( x < 67 )  return "1";
			else if( x < 137 ) return "2";
			else 			   return "3";

		}
		else if( y < 67 ) //4, 5, 6
		{

				 if( x < 67 )  return "4";
			else if( x < 137 ) return "5";
			else 			   return "6";

		}
		else if( y < 102 ) // 7, 8, 9
		{

				 if( x < 67 )  return "7";
			else if( x < 137 ) return "8";
			else 			   return "9";


		}
		else //*, 0, #
		{

				 if( x < 67 )  return "*";
			else if( x < 137 ) return "0";
			else 			   return "#";

		}

	}

	var zeroLongPressTimer = undefined
	var alreadyMatchedLongpress = false
	$(".dialpad-numberpad", ".call-dialpad").unbind().bind('mouseup', function(e)
	{

		var pressed = $(this).getkeyPadInputFromEvent(e)
		clearTimeout(zeroLongPressTimer)
		if( alreadyMatchedLongpress )
		{

			//character already placed
			alreadyMatchedLongpress = false

		}
		else
		{

			//if dial input visible then echo, else in call so send DTMF
			if( $(this).parent().children(".call-dialpadDialInput").is(":visible") )
			{
				$(".phoneMiniDialInput", ".call-dialpadDialInput").attr("value", $(".phoneMiniDialInput", ".call-dialpadDialInput").attr("value") + pressed)
				$('.phoneMiniDialInput','.call-dialpad').focus()
			}
			else
				$phone.params.flashConnectorHandle.sendDTMF( $phone.params.flashConnectorHandle.getCurrentCall()['id'], pressed )

		}


	}).bind('mousedown', function(e) {

		e.preventDefault();

		var _pressed = $(this).getkeyPadInputFromEvent(e)
		var _this = this
		zeroLongPressTimer = setTimeout(function()
			{
				alreadyMatchedLongpress = true;
				var intended = (_pressed=="0"?"+":_pressed)
				if( $(_this).parent().children(".call-dialpadDialInput").is(":visible") )
				{
					$(".phoneMiniDialInput", ".call-dialpadDialInput").attr("value", $(".phoneMiniDialInput", ".call-dialpadDialInput").attr("value") + intended);
					$('.phoneMiniDialInput','.call-dialpad').focus()
				}
				else
					$phone.params.flashConnectorHandle.sendDTMF( $phone.params.flashConnectorHandle.getCurrentCall()['id'], intended )
			},1000)

	})

	var showPhoneDDTimeout = undefined
	$(".phoneOptions")
		.mouseenter( function() { if( showPhoneDDTimeout != undefined ) clearTimeout(showPhoneDDTimeout) })
		.mouseleave( function() { showPhoneDDTimeout = setTimeout( "$('.phoneOptions').hide()", 1000); })
		.click( function() { clearTimeout(showPhoneDDTimeout); $('.phoneOptions').hide(); })

	$phone.inboundAnsweredUICallback = function(call)
	{

		//$phone.log("inboundAnsweredUICallback(call):")
		//$phone.log(call)
		//normally transitioning from inboundRinging so not much to change
		$('.phoneRemoteImg', ".call-connected").attr('src', siteBaseUrl + "images/themes/" + $phone.params.cssStyleTheme + "/contact-photo.png")
		$phone.setNewContactFlag(false)

		var caller = $phone.humanize(call.caller)

		if( call.visibleNameCaller && call.visibleNameCaller.indexOf("Callback") != -1 )
		{

			callbackName = call.visibleNameCaller.substring(0,call.visibleNameCaller.indexOf("Callback"))
			$(".phoneRemoteName", ".call-connected").html( callbackName )
			$(".phoneRemoteNumber", ".call-connected").html( "Callback" )

		}
		else
		{

			$('.phoneRemoteName', ".call-connected").html('')
			$('.phoneRemoteNumber', ".call-connected").html(caller)

			$.ajax({
				url: moduleBaseUrl + "/contacts/whois/search/" + caller,
				method: 'GET',
				dataType: 'json',
				success: function(data, type)
				{
					updateContactFromAbook(data, caller)
				}
	        });

		}
		$(".phoneCallStatus", ".call-connected").html('Connecting...')
		$(".call-wait").show()
		setTimeout( function() {
			$(".call-wait").hide()
			if(isCallEnded()) return;

			$(".phoneCallStatus", ".call-connected").html('In call')
			$(".phoneTimer", ".call-connected").show()

		}, 2000)
		$(".phoneCallStatus2", ".call-connected").html('').hide()
        $('.phoneTimer', '#secondary').hide().html("00");
		countdownStart()

		//$(".buttonClose", ".call-connected").hide()
		//$(".buttonEnd", ".call-connected").show()
		//$(".buttonMuteUnmute", ".call-connected").show()
		//$(".buttonHoldRetrieve", ".call-connected").show()
		$(".callNotifyIncoming").dialog("close")
		//$(".buttonTransferPrep", ".call-connected").show()
		$phone.showCallDetails()

		contact = $phone.getBasicSIPURIFromRawInput(call.caller);
		$('.caller-details', '.call-connected').attr('uri', contact)

		this.params.uiMainMode = "inCall"
		$phone.refreshLog('CDR');
	}

	$phone.outboundRingingUICallback = function(call)
	{

		//change dialing to Call failed and status 2 to reason
		$(".phoneCallStatus", ".call-connected").html('Ringing.')

	}

	$phone.outboundAnsweredUICallback = function( call )
	{
        $('.phoneTimer', '#secondary').show().html("00");
		//this can only happen in inCall-pendingCallOutbound and pendingCallInbound uiMainMode
		this.log("calling outboundAnsweredUICallback with uiMainMode=" + this.params.uiMainMode)
		$(".phoneCallStatus", ".call-connected").html('Connecting...')
		$(".call-wait").show()
		setTimeout( function() {

			$(".call-wait").hide()
			$(".phoneCallStatus", ".call-connected").html('In call')
			$(".phoneTimer", ".call-connected").show()

		}, 2000)

		countdownStart()
		//$(".phoneTimer", ".call-connected").hide().countdown({since: 0, compact: true, format: "hmS", description: ""})
		//$(".buttonClose", ".call-connected").hide()
		//$(".buttonRetry",  ".call-connected").hide()
		//$(".buttonHoldUnhold",  ".call-connected").show()
		//$(".buttonEnd",  ".call-connected").show()
		//$(".buttonMuteUnmute", ".call-connected").show()
		//$(".buttonTransferPrep", ".call-connected").show()
		$phone.showCallDetails()
		this.params.uiMainMode == "inCall"

	}

	$phone.localHungupUICallback = function(call) //local or remote
	{

		if( $phone.callQualityTimer != null )
			clearInterval($phone.callQualityTimer)
		$(".phoneCallStatus", ".call-connected").html( "Call ended" )
		$(".phoneCallStatus2", ".call-connected").html( "" )
		countdownDestroy()
		$(".phoneMiniDialInput", ".phoneMiniDial").attr("value","")

		$phone.showCallDetails()
		$phone.showRedialPad()

		// refresh call folder
		$phone.refreshLog('CDR');

		$(".buttonMuteUnmute").each(function(){
			if($(this).attr("muted") != "false") {

				$phone.muteUnmute(false);
				$(this).attr("muted","false");
				$(this).removeClass("UnMute");
				$(this).find('strong').html('Mute');
			}
		});

	}

	$phone.outboundFailedUICallback = function(reasonCode, reasonEnglish, callee)
	{
		$(".phoneCallStatus", ".call-connected").html( "Call Failed" )
		$(".phoneCallStatus2", ".call-connected").html( reasonEnglish ).show();
		$('.call-detail', '.call-connected').removeAttr('newContactFlag');
		$phone.showCallDetails()
		$phone.showRedialPad()
		$phone.refreshLog('CDR');

	}

	$phone.remoteHungupUICallback = function(call) //local or remote
	{

		if(call && call.sip_state == "402") {
			alert("Insufficient credit.");
		}
		if( $phone.callQualityTimer != null )
			clearInterval($phone.callQualityTimer)
		//$phone.hangup()
		$phone.localHungupUICallback(call)//call it immediately even although $phone will callback it once server finishes hangup

	}

	//bind the newIM button to the first SMS pid found
	$phone.newIM = function(toNumber, messageBody)
	{

		//$("#phoneIMPanel").dialog("open")
		var dataSourceURL = appBaseUrl + "/api/unify/ucdbget"
		var dataSourceParams = {
			pid : this.params.pid,
			serviceType : this.params.serviceType,
			serviceName : this.params.serviceName,
			serviceDesription : undefined,
			myId : this.params.userId,
			myDisplayName : this.params.displayName,
			folder : "SMS",
			limit : "50",
			toNumber : toNumber,
			renderMethod: "renderComposer",
			messageBody: messageBody,
			suppressRecipientActions: true
		}
		$.localData.checkProviderStoreReady(dataSourceParams)
		var localDataNode = $.localData.dataStore["pid"+dataSourceParams.pid].folders[dataSourceParams.folder]

		$("#nav").tabs("select",0)
		$("#navMessages").tabs("select",0)

		$("DIV.current", "#Email").removeClass('current');
		$('.jsServiceProvider[folder=SMS]', '.serviceFolderGroup').parent().addClass('current');

		$('#Email #primary #messageList').showPanel(dataSourceURL,dataSourceParams, localDataNode, $.templateEngine.templates.SIP["SMS"] )

	}

	$phone.popIncomingCallCallback = function(callObject)
	{
		$.templateEngine.templates.SIP["SMS"].showIncomingCallToaster(callObject)

	}

	$phone.newMessageUICallback = function(messageObject, sipObject)
	{

		/*
		unconditional forward must notify UI
			< ?xml version="1.0" encoding="UTF-8"? > 
			<fs-services xmlns="urn:vas:params:xml:ns:fs-services"> 
			<fs-service action="servicenoti-indicate"> 
			<cfu> 
			<cfu-data sender="0000000" tdn="1111111" time="2012-05-23T14:48:04+08:00"/> 
			</cfu> 
			</fs-service> 
			</fs-services>

		----------------------------------
		forward on BUSY must not notify UI

			< ?xml version="1.0" encoding="UTF-8"? > 
			<fs-services xmlns="urn:vas:params:xml:ns:fs-services"> 
			<fs-service action="servicenoti-indicate"> 
			<mcn> 
			<mcn-data sender="0000000" time="2012-05-23T14:52:11+08:00"/> 
			</mcn> 
			</fs-service> 
			</fs-services>

		*/

		this.log("newMessageUICallback(messageObject): ")
		this.log( jQuery.extend({}, messageObject) )
		this.log( jQuery.extend({}, sipObject) )

		var nowTimestampUnix = Math.round((+Date.now() || +new Date)/1000)

		var src = $phone.getBasicSIPURIArrayFromRawInput(messageObject.from).join()
		if( messageObject.recipients == undefined || messageObject.recipients == '')
			messageObject.recipients = messageObject.to
		var dst = $phone.getBasicSIPURIArrayFromRawInput(messageObject.recipients).join()

		if(typeof (messageObject.recipients) == 'undefined')
			this.log("What caused this message to have recipients of undefined?")

		//if message does not have an id then make one
		if( messageObject.id == undefined )
			messageObject.id = messageObject.to + nowTimestampUnix + Math.floor(Math.random()*1000)

		var ajaxData = {"state" : messageObject.state, "id" : messageObject.id }
		var toasterTitle = undefined
		var messageBody = undefined

		//ignore friend requests
		//Accept-Contact: *;+g.oma.sip-im;+g.oma.sip-im.device-message 
		if( sipObject.message != undefined && sipObject.message.raw != undefined && sipObject.message.raw.indexOf("Accept-Contact: *;+g.oma.sip-im;+g.oma.sip-im.device-message") != -1 )
		{

			//this.log( 'indexfolderlist.phtml #1846: matched friend request:' )
			return

		}

		if( messageObject.contentType != undefined && messageObject.contentType == "application/fsservice+xml" )						//Missed call message
		{

			//CONSIDER: visual UI feedback of status/result of Feature code request.
			//if Feature code confirmation message, suppress UI feedback
			if( src == dst )
				return

			//if it turnes out to be a Message Forwarding message then ignore
			if( sipObject.message.raw.indexOf("<cfu>") == -1 ) // only notify for Unconditional call Forwarding. missed call notification tag not found so ignore (e.g. call forwarded notice)
				return

			ajaxData.delivered = nowTimestampUnix
			ajaxData.message = messageBody
			ajaxData.src =  src
			ajaxData.dst = dst //me
			ajaxData.state = "MISSED"
			ajaxData.itemtype = "call"

			this.log("Missed call")
			var toasterTitle = "Missed call"
			var person = src
			var messageBody = "Missed call"

		}
		else if( messageObject.contentType != undefined && messageObject.contentType == "application/vnd.oma.push" )					//Voicemail message
		{

			var toasterTitle = "New voicemail"
			var xmlString = messageObject.body

			//ignore NAB Sync notifications
			if( xmlString.indexOf("SYNC-ALERT") != -1 )
				return
			//var person = $(xmlString).find('ni-data').attr('sender') !!! IE8 broken
			var regex_res = /sender="(.*?)"/i.exec(xmlString);
			var person = regex_res? regex_res[1] : '';

			//don't notify or log messages from sender="VoiceMessage@myimsserver.com" = (No messages notification) = ignore
			if( person =="VoiceMessage@myimsserver.com" )
				return false
			this.log("New voicemail") //messageObject.id, person, messageBody, toasterTitle
			person = $phone.getBasicSIPURIFromRawInput(person)

			//var content = $(xmlString).find('ni-data').attr('content') !!! IE8 broken
			var regex_res = /content="(.*?)"/i.exec(xmlString);
			var content = regex_res? regex_res[1] : '';

			if(content)
			{
				content = content.replace(". There are",".\nThere are")
				content = content.replace("You have a new voice message from","New voice message from")
				content = content + "\nTo access your Voicemail, please dial 121."

			}
			//var time = $(xmlString).find('ni-data').attr('time') //e.g. 2012-04-05T13:58:13+08:00
			//var messageBody = content + "\n" + time

			//ajaxData = undefined 																										// suppress VM notifications from being logged
			ajaxData.init = nowTimestampUnix
			ajaxData.delivered = nowTimestampUnix
			ajaxData.message = content
			ajaxData.src =  person
			ajaxData.dst = dst //me
			ajaxData.state = "RECEIVED"
			ajaxData.itemtype = "sms"
			ajaxData.extra = "VOICEMAIL"
			$phone.notifyUIOfUnreadSMS()

		}
		else if( sipObject.message.raw.indexOf("Message-Type: report_sm") > 0 && sipObject.message.raw.indexOf("delivery-notification") > 0 && sipObject.message.raw.indexOf("undeliverable") > 0 )
		{

			//Wrong number, target network side delivery failed after being accepted by home netowrk for delivery.
			this.log( 'indexfolderlist.phtml #2094: Delivery failed' )
			ajaxData.failed = nowTimestampUnix
			delete ajaxData.message
			delete ajaxData.src
			delete ajaxData.dst
			ajaxData.state = "FAILED"
			var toasterTitle = "Delivery failed."
			var person = dst
			var messageBody = ""
		}
		else if( messageObject.state == "RECEIVED")																						//all other received messages except voicemail messages
		{

			ajaxData.init = nowTimestampUnix
			ajaxData.delivered = nowTimestampUnix
			ajaxData.message = messageObject.body
			ajaxData.src =  src
			ajaxData.dst = dst //me

			this.log("New message")
			var toasterTitle = "New SMS"
			var person = src
			var messageBody = messageObject.body
			$phone.notifyUIOfUnreadSMS()

		}
		else if( messageObject.state == "SENT" ) //actually init
		{

			this.log("Message successfully accepted for sending")
			ajaxData.sent = nowTimestampUnix
			ajaxData.message = messageObject.body
			ajaxData.src =  src
			ajaxData.dst = dst
			ajaxData.init = true;
			this.log( 'indexfolderlist.phtml #1590: :' )


			//try update icon of new line in view (if visible)
			if( $(".jsDetailRow.smsOutgoing:first", "#primary").attr("oid") == "0" && $(".jsDetailRow.smsOutgoing:first .SMSMessage", "#primary").text() == messageObject.body )
			{

				$(".jsDetailRow.smsOutgoing:first .SMSIcon img", "#primary").attr("src", siteBaseUrl + "images/webphone/sent.gif")
				$(".jsDetailRow.smsOutgoing:first", "#primary").attr("oid", messageObject.id)
				this.log( 'indexfolderlist.phtml #1599: :' )


			}

		}
		else if( messageObject.state == "ACCEPTED" ) //actually accepted as sent from user
		{

			this.log("Message successfully sent")
			ajaxData.init = nowTimestampUnix
			ajaxData.message = messageObject.body
			ajaxData.src =  src
			ajaxData.dst = dst

		}
		else if( messageObject.state == "DELIVERED" )
		{

			//TODO update outgoing DOM line icon
			ajaxData.delivered = nowTimestampUnix

			var toasterTitle = "Message delivered"
			var person = dst
			var messageBody = messageObject.body

		}
		else if( messageObject.state == "READ" )
		{

			ajaxData.read = nowTimestampUnix

		}
		else if( messageObject.state == "FAILED" && sipObject.message.code == "402" )
		{

			//Out of credit.
			ajaxData.failed = nowTimestampUnix
			delete ajaxData.message
			delete ajaxData.src
			delete ajaxData.dst
			ajaxData.state = "FAILED"
			console.log( 'indexfolderlist.phtml #2114: FAILED:' )
			console.log( ajaxData )

			//ajaxData.message = "FAILED"


			var toasterTitle = "Insufficient Credit"
			var person = "Sending Failed."
			var messageBody = messageObject.body
		}
		else if( messageObject.state == "FAILED" )
		{

			//TODO update outgoing DOM line icon
			ajaxData.failed = nowTimestampUnix

			var toasterTitle = "Message failed"
			var person = dst
			var messageBody = messageObject.body
		}

		if( ajaxData != undefined )
		{

			this.log("#######################About to log Message to UCDB: ")
			this.log(ajaxData)

			if(ajaxData.state === 'FAILED') {

				setTimeout(function() 
				{
					$.ajax(
					{
						url: appBaseUrl + "/api/unify/ucdbput",
						method: 'POST',
						dataType: 'json',
						data : ajaxData,
						success: function(response, type)
						{
						}
					})
				}, 3000);
			}
			else {

				$.ajax(
				{
					url: appBaseUrl + "/api/unify/ucdbput",
					method: 'POST',
					dataType: 'json',
					data : ajaxData,
					success: function(response, type)
					{
					}
				})

			}

		}
		else
			this.log( 'indexfolderlist.phtml #1989: Not logging to UCDB as per event rules.' )

		if( toasterTitle != undefined )
		{
			$.templateEngine.templates.SIP["SMS"].showFolderToaster.call($.templateEngine.templates.SIP["SMS"], null, this.params.pid, messageObject.id, person, messageBody, toasterTitle )
			if( messageObject.state != "DELIVERED" )
				$('#jquery_jplayer:first').jPlayer('setFile', siteBaseUrl + 'sounds/Toaster_Pop.mp3', siteBaseUrl + 'sounds/Toaster_Pop.ogg').jPlayer('play');
		}

		if(messageObject.state == "FAILED") {
			setTimeout( function(){
				$('.SMSComposerMessageInput','#messageList').val(messageBody)
			}, 3000);
		}
	}

	// Dialpad dropdown
	$('.mini-drop #jsddm > li').bind('mousedown', jsddm_open)

	$('.phoneMiniDialButton','#Email').attr('disabled','true').css('opacity','0.5');

	function checkucdb()
	{
		$.ajax({
			url: appBaseUrl + "/api/unify/ucdbchecklogin",
			method: 'POST',
			dataType: 'json',
			cache: false,
			success: function(response, type)
			{
				if(response.result == 'fail') 
				{
					_ucdbLoginFlag = false;
					//hideucdbFolders()
				}
			}
		})
	}

	if($phone.hasSipFolder())
	{
		checkucdb()
	}
	
});

