<?php

// bc math helper functions
function base_convert_x($_number = '', $_frBase = 10, $_toBase = 62)
{
	$_10to62 = array(
		'0' => '0', '1' => '1', '2' => '2', '3' => '3', '4' => '4', '5' => '5', '6' => '6', '7' => '7', '8' => '8', '9' => '9',
		'00' => '0', '01' => '1', '02' => '2', '03' => '3', '04' => '4', '05' => '5', '06' => '6', '07' => '7', '08' => '8', '09' => '9',
		'10' => 'A', '11' => 'B', '12' => 'C', '13' => 'D', '14' => 'E', '15' => 'F', '16' => 'G', '17' => 'H', '18' => 'I', '19' => 'J',
		'20' => 'K', '21' => 'L', '22' => 'M', '23' => 'N', '24' => 'O', '25' => 'P', '26' => 'Q', '27' => 'R', '28' => 'S', '29' => 'T',
		'30' => 'U', '31' => 'V', '32' => 'W', '33' => 'X', '34' => 'Y', '35' => 'Z',
		'36' => 'a', '37' => 'b', '38' => 'c', '39' => 'd', '40' => 'e', '41' => 'f', '42' => 'g', '43' => 'h', '44' => 'i', '45' => 'j',
		'46' => 'k', '47' => 'l', '48' => 'm', '49' => 'n', '50' => 'o', '51' => 'p', '52' => 'q', '53' => 'r', '54' => 's', '55' => 't',
		'56' => 'u', '57' => 'v', '58' => 'w', '59' => 'x', '60' => 'y', '61' => 'z');

	$_62to10 = array(
		'0' => '00', '1' => '01', '2' => '02', '3' => '03', '4' => '04', '5' => '05', '6' => '06', '7' => '07', '8' => '08', '9' => '09',
		'A' => '10', 'B' => '11', 'C' => '12', 'D' => '13', 'E' => '14', 'F' => '15', 'G' => '16', 'H' => '17', 'I' => '18', 'J' => '19',
		'K' => '20', 'L' => '21', 'M' => '22', 'N' => '23', 'O' => '24', 'P' => '25', 'Q' => '26', 'R' => '27', 'S' => '28', 'T' => '29',
		'U' => '30', 'V' => '31', 'W' => '32', 'X' => '33', 'Y' => '34', 'Z' => '35',
		'a' => '36', 'b' => '37', 'c' => '38', 'd' => '39', 'e' => '40', 'f' => '41', 'g' => '42', 'h' => '43', 'i' => '44', 'j' => '45',
		'k' => '46', 'l' => '47', 'm' => '48', 'n' => '49', 'o' => '50', 'p' => '51', 'q' => '52', 'r' => '53', 's' => '54', 't' => '55',
		'u' => '56', 'v' => '57', 'w' => '58', 'x' => '59', 'y' => '60', 'z' => '61');

	#   ---- First convert from frBase to base-10

	$_in_b10 = 0;
	$_pwr_of_frB = 1; #  power of from base, eg. 1, 8, 64, 512
	$_chars = str_split($_number); #  split input # into chars
	$_str_len = strlen($_number);
	$_pos = 0;

	while ($_pos++ < $_str_len)
	{
		$_char = $_chars[$_str_len - $_pos];
		$_in_b10 += (((int)$_62to10[$_char]) * $_pwr_of_frB);
		$_pwr_of_frB *= $_frBase;
	}

	#   ---- Now convert from base-10 to toBase

	$_dividend = (int)$_in_b10; #  name dividend easier to follow below
	$_in_toB = ''; #  number string in toBase

	while ($_dividend > 0)
	{

		$_quotient = (int)($_dividend / $_toBase); #  eg. 789 / 62  =  12  ( C in base 62 )
		$_remainder = '' . ($_dividend % $_toBase); #  789 % 62  =  45  ( j in base 62 )
		$_in_toB = $_10to62[$_remainder] . $_in_toB; #  789  (in base 10)  =    Cj  (in base 62)
		$_dividend = $_quotient; #  new dividend is the quotient from base division
	}

	if ($_in_toB == '')
	{
		$_in_toB = '0';
	}

	return $_in_toB; #  base $_toBase string
}

function bc_comp($v, $v2, $v3)
{
	// Returns 0 if the two operands are equal, 1 if the left_operand is larger than the right_operand, -1 otherwise.
	$v = intval($v);
	$v2 = intval($v2);
	if ($v == $v2) return 0;
	else if ($v > $v2) return 1;
	return -1;
}

// based on Andrius Baranauskas and Laurynas Butkus :) Vilnius, Lithuania
function bc_mod( $x, $y )
{
	// how many numbers to take at once? carefull not to exceed (int)
	$take = 5;
	$mod = '';
	if(strpos($x, ".") !== false)
	{
		$x = substr($x, 0, strpos($x, "."));
	}
	do
	{
		$a = (int)$mod.substr( $x, 0, $take );
		$x = substr( $x, $take );
		$mod = $a % $y;
	}
	while ( strlen($x) );

	return (int)$mod;
}

function bc_baseconvert($str, $frombase = 10, $tobase = 36)
{
	if (is_numeric($str) && substr($str, 0, 1) == '-')
	{
		$str = sprintf("%u", $str);
		if ($str == 0)
		{
			$str = '0';
		}
	}

	$str = trim($str);

	if (intval($frombase) != 10)
	{
		$len = strlen($str);
		$q = 0;
		for ($i = 0; $i < $len; $i++)
		{
			$r = base_convert_x($str[$i], $frombase, 10);
			$q = ($q * $frombase) + $r;
		}
	} else
	{
		$q = $str;
	}

	if (intval($tobase) != 10)
	{
		$s = '';
		if (bc_comp($q, 0, 0) <= 0)
		{
			$s = $q;
		} else
		{
			while (bc_comp($q, 0, 0) > 0)
			{
				$r = intval(bc_mod($q, $tobase));
				$s = base_convert_x($r, 10, $tobase) . $s;
				$q = $q / $tobase;
			}
		}
	} else
	{
		$s = $q;
	}

	return $s;
}
